/************************************************************************
 *                              scandir.c                               *
 *                      File list handling routines                     *
 *                                                                      *
 * 88Jul17 orc  Created.                                                *
 *                                                                      *
 ************************************************************************/

#include "ctdl.h"
#include "dirlist.h"
#include "clock.h"
#include "dateread.h"
#include <stdlib.h>

/************************************************************************
 *                              Contents                                *
 *                                                                      *
 *      * filedate()            parse a file date for .r+/.r-           *
 *      scandir()               gets list of files.                     *
 *      freedir()               Free file list.                         *
 *      getArea()               get an area from the sysop.             *
 *                                                                      *
 ************************************************************************/

/*
 ****************************************************************
 *      filedate() -- convert a file date (like parsedate)      *
 ****************************************************************
 */
long filedate(p)
struct dirList *p;
{
    now.dy = p->fd_date._day;
    now.mo = p->fd_date._month;
    now.yr = p->fd_date._year;
    return julian_date(&now);
}


/*
 ************************************************************************
 *      scandir() - Get a list of files from the current directory      *
 ************************************************************************
 */
scandir(mask, list)
char *mask;
struct dirList **list;
{
    register count = 0;
    int size;
    struct dirList *p, *temp, *ptr;
    struct dirList *getdirentry();
    char tmask[80];
    char *file, *strtok();

    p = *list = NULL;

    if (strchr(mask, ':') || strchr(mask, '\\'))
        return 0;

    strcpy(tmask, mask);

    /*
     * Incredibly ugly code follows.
     */
    for (file=strtok(tmask,"\t "); file; file=strtok(NULL,"\t ")) 
    {
        for (ptr=getdirentry(file); ptr; ptr=getdirentry(NULL)) 
        {
            if (dPass && !dateok(filedate(ptr)))
                continue;

            if (count % 50 == 0) 
            {
                size = (50 + count) * sizeof ptr[0];
                temp = p ? realloc(p, size) : malloc(size);
                if (temp == NULL) 
                {
                    mPrintf("Out of memory!\n ");
                    break;
                }
                p = temp;
            }
            copy_struct(*ptr, p[count]);
            ++count;
        }
    }
    *list = p;
    return count;
}


/*
 ****************************************************************
 *      freedir() - Frees the file list generated by scandir    *
 ****************************************************************
 */
freedir(list, count)
struct dirList *list;
int count;
{
    if (count>0)
        free(list);
}
